package com.datacloudsec.scan.cache;

import com.datacloudsec.scan.common.Constant;
import com.datacloudsec.utils.JsonUtil;
import com.datacloudsec.utils.SecretUtil;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.apache.commons.io.IOUtils;
import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

public class PoliciesSingleton {

   private Map policesConfig;
   private static PoliciesSingleton instance;
   private static long lastMdfTime;
   private static File confFile = new File(Constant.WORK_DIR, "conf/policies.xml");
   private String version;


   public static synchronized PoliciesSingleton getInstance() throws Exception {
      if(instance == null) {
         instance = new PoliciesSingleton();
      }

      if(confFile.lastModified() != lastMdfTime) {
         instance.policesConfig = new HashMap();
         SAXReader reader = new SAXReader();
         Object b = null;

         byte[] b1;
         try {
            b1 = SecretUtil.decryptEncrypt("aes", IOUtils.toByteArray(new FileInputStream(confFile)), "anshuyun123SEF@#".getBytes());
         } catch (Exception var12) {
            b1 = IOUtils.toByteArray(new FileInputStream(confFile));
         }

         Document document = reader.read(new ByteArrayInputStream(b1));
         Element root = document.getRootElement();
         instance.version = root.attributeValue("version");
         List eleList = root.elements();
         Iterator var6 = eleList.iterator();

         while(var6.hasNext()) {
            Element ele = (Element)var6.next();
            Attribute attr = ele.attribute("id");
            List listEle = ele.elements();
            HashMap map = new HashMap();
            Iterator var11 = listEle.iterator();

            while(var11.hasNext()) {
               Element childE = (Element)var11.next();
               map.put(childE.getName().toLowerCase(), childE.getText());
            }

            instance.policesConfig.put(attr.getValue(), map);
         }
      }

      return instance;
   }

   public static void main(String[] args) throws Exception {
      System.out.println(JsonUtil.MAPPER.writeValueAsString(getInstance().getPolicesConfig()));
   }

   public Map getPolicesConfig() {
      return this.policesConfig;
   }

   public String getVersion() {
      return this.version;
   }
}
